Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/ParameterType.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/ParameterType.cs	(revision 2033)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/ParameterType.cs	(revision 2033)
@@ -0,0 +1,44 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+
+namespace HeuristicLab.Core {
+  /// <summary>
+  /// Represents the type of a parameter (input, output, both).
+  /// </summary>
+  public enum ParamterType {
+    /// <summary>
+    /// Value representing an input parameter.
+    /// </summary>
+    In,
+    /// <summary>
+    /// Value representing an output parameter.
+    /// </summary>
+    Out,
+    /// <summary>
+    /// Value representing an input and output parameter.
+    /// </summary>
+    InOut
+  }
+}
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/ParameterView.Designer.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/ParameterView.Designer.cs	(revision 2033)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/ParameterView.Designer.cs	(revision 2033)
@@ -0,0 +1,165 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Core {
+  partial class ParameterView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.dataTypeLabel = new System.Windows.Forms.Label();
+      this.dataTypeTextBox = new System.Windows.Forms.TextBox();
+      this.descriptionLabel = new System.Windows.Forms.Label();
+      this.descriptionTextBox = new System.Windows.Forms.TextBox();
+      this.typeLabel = new System.Windows.Forms.Label();
+      this.typeTextBox = new System.Windows.Forms.TextBox();
+      this.nameTextBox = new System.Windows.Forms.TextBox();
+      this.nameLabel = new System.Windows.Forms.Label();
+      this.SuspendLayout();
+      // 
+      // dataTypeLabel
+      // 
+      this.dataTypeLabel.AutoSize = true;
+      this.dataTypeLabel.Location = new System.Drawing.Point(3, 29);
+      this.dataTypeLabel.Name = "dataTypeLabel";
+      this.dataTypeLabel.Size = new System.Drawing.Size(60, 13);
+      this.dataTypeLabel.TabIndex = 2;
+      this.dataTypeLabel.Text = "&Data Type:";
+      // 
+      // dataTypeTextBox
+      // 
+      this.dataTypeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.dataTypeTextBox.Location = new System.Drawing.Point(81, 26);
+      this.dataTypeTextBox.Name = "dataTypeTextBox";
+      this.dataTypeTextBox.ReadOnly = true;
+      this.dataTypeTextBox.Size = new System.Drawing.Size(188, 20);
+      this.dataTypeTextBox.TabIndex = 3;
+      // 
+      // descriptionLabel
+      // 
+      this.descriptionLabel.AutoSize = true;
+      this.descriptionLabel.Location = new System.Drawing.Point(3, 81);
+      this.descriptionLabel.Name = "descriptionLabel";
+      this.descriptionLabel.Size = new System.Drawing.Size(63, 13);
+      this.descriptionLabel.TabIndex = 6;
+      this.descriptionLabel.Text = "&Description:";
+      // 
+      // descriptionTextBox
+      // 
+      this.descriptionTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.descriptionTextBox.Location = new System.Drawing.Point(81, 78);
+      this.descriptionTextBox.Multiline = true;
+      this.descriptionTextBox.Name = "descriptionTextBox";
+      this.descriptionTextBox.ReadOnly = true;
+      this.descriptionTextBox.Size = new System.Drawing.Size(188, 131);
+      this.descriptionTextBox.TabIndex = 7;
+      // 
+      // typeLabel
+      // 
+      this.typeLabel.AutoSize = true;
+      this.typeLabel.Location = new System.Drawing.Point(3, 55);
+      this.typeLabel.Name = "typeLabel";
+      this.typeLabel.Size = new System.Drawing.Size(34, 13);
+      this.typeLabel.TabIndex = 4;
+      this.typeLabel.Text = "&Type:";
+      // 
+      // typeTextBox
+      // 
+      this.typeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.typeTextBox.Location = new System.Drawing.Point(81, 52);
+      this.typeTextBox.Name = "typeTextBox";
+      this.typeTextBox.ReadOnly = true;
+      this.typeTextBox.Size = new System.Drawing.Size(188, 20);
+      this.typeTextBox.TabIndex = 5;
+      // 
+      // nameTextBox
+      // 
+      this.nameTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.nameTextBox.Location = new System.Drawing.Point(81, 0);
+      this.nameTextBox.Name = "nameTextBox";
+      this.nameTextBox.ReadOnly = true;
+      this.nameTextBox.Size = new System.Drawing.Size(188, 20);
+      this.nameTextBox.TabIndex = 1;
+      // 
+      // nameLabel
+      // 
+      this.nameLabel.AutoSize = true;
+      this.nameLabel.Location = new System.Drawing.Point(3, 3);
+      this.nameLabel.Name = "nameLabel";
+      this.nameLabel.Size = new System.Drawing.Size(38, 13);
+      this.nameLabel.TabIndex = 0;
+      this.nameLabel.Text = "&Name:";
+      // 
+      // ParameterView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.dataTypeTextBox);
+      this.Controls.Add(this.typeTextBox);
+      this.Controls.Add(this.descriptionTextBox);
+      this.Controls.Add(this.nameTextBox);
+      this.Controls.Add(this.dataTypeLabel);
+      this.Controls.Add(this.typeLabel);
+      this.Controls.Add(this.nameLabel);
+      this.Controls.Add(this.descriptionLabel);
+      this.Name = "ParameterView";
+      this.Size = new System.Drawing.Size(269, 209);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Label dataTypeLabel;
+    private System.Windows.Forms.TextBox dataTypeTextBox;
+    private System.Windows.Forms.Label descriptionLabel;
+    private System.Windows.Forms.TextBox descriptionTextBox;
+    private System.Windows.Forms.Label typeLabel;
+    private System.Windows.Forms.TextBox typeTextBox;
+    private System.Windows.Forms.TextBox nameTextBox;
+    private System.Windows.Forms.Label nameLabel;
+  }
+}
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/ParameterView.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/ParameterView.cs	(revision 2033)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/ParameterView.cs	(revision 2033)
@@ -0,0 +1,71 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Text;
+using System.Windows.Forms;
+
+namespace HeuristicLab.Core {
+  public partial class ParameterView : ViewBase {
+    public IParameter Parameter {
+      get { return (IParameter)Item; }
+      set { base.Item = value; }
+    }
+
+    public ParameterView() {
+      InitializeComponent();
+      Caption = "Parameter";
+    }
+    public ParameterView(IParameter parameter)
+      : this() {
+      Parameter = parameter;
+    }
+
+    /// <summary>
+    /// Updates all controls with the latest data of the model.
+    /// </summary>
+    /// <remarks>Calls <see cref="ViewBase.UpdateControls"/> of base class <see cref="ViewBase"/>.</remarks>
+    protected override void UpdateControls() {
+      base.UpdateControls();
+      Caption = "Parameter";
+      if (Parameter == null) {
+        nameTextBox.Enabled = false;
+        dataTypeTextBox.Enabled = false;
+        typeTextBox.Enabled = false;
+        descriptionTextBox.Enabled = false;
+      } else {
+        Caption = Parameter.Name + " (" + Parameter.GetType().Name + ")";
+        nameTextBox.Text = Parameter.Name;
+        nameTextBox.Enabled = true;
+        dataTypeTextBox.Text = Parameter.DataType.FullName;
+        dataTypeTextBox.Enabled = true;
+        typeTextBox.Text = Parameter.Type.ToString();
+        typeTextBox.Enabled = true;
+        descriptionTextBox.Text = Parameter.Description;
+        descriptionTextBox.Enabled = true;
+      }
+    }
+  }
+}
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/ParameterView.resx
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/ParameterView.resx	(revision 2033)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/ParameterView.resx	(revision 2033)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/PersistenceManager.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/PersistenceManager.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/PersistenceManager.cs	(revision 2033)
@@ -41,9 +41,9 @@
     /// <param name="instance">The object that should be saved.</param>
     /// <param name="filename">The name of the file where the <paramref name="object"/> should be saved.</param>
-    public static void Save(IStorable instance, string filename) {
+    public static void Save(object instance, string filename) {
       XmlGenerator.Serialize(instance, filename, 0);
     }
 
-    public static void SaveCompressed(IStorable instance, string filename) {
+    public static void SaveCompressed(object instance, string filename) {
       XmlGenerator.Serialize(instance, filename, 9);
     }
@@ -55,5 +55,5 @@
     /// <param name="instance">The object that should be saved.</param>
     /// <param name="stream">The (file) stream where the object should be saved.</param>
-    public static void Save(IStorable instance, Stream stream) {
+    public static void Save(object instance, Stream stream) {
       XmlGenerator.Serialize(instance, stream, ConfigurationService.Instance.GetConfiguration(new XmlFormat()));      
     }
@@ -65,6 +65,6 @@
     /// <param name="filename">The filename of the file where the data is saved.</param>
     /// <returns>The loaded object.</returns>
-    public static IStorable Load(string filename) {
-      return (IStorable)XmlParser.Deserialize(filename);
+    public static object Load(string filename) {
+      return XmlParser.Deserialize(filename);
     }
     /// <summary>
@@ -75,6 +75,6 @@
     /// <param name="stream">The stream from where to load the data.</param>
     /// <returns>The loaded object.</returns>
-    public static IStorable Load(Stream stream) {
-      return (IStorable)XmlParser.Deserialize(stream);
+    public static object Load(Stream stream) {
+      return XmlParser.Deserialize(stream);
     }
 
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Scope.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Scope.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Scope.cs	(revision 2033)
@@ -45,5 +45,5 @@
     
     private IDictionary<string, IVariable> myVariables;
-    /// <inheritdoc/>    
+    /// <inheritdoc/>
     public ICollection<IVariable> Variables {
       get { return myVariables.Values; }
@@ -224,15 +224,4 @@
     }
     /// <inheritdoc/>
-    public IScope GetScope(Guid guid) {
-      if (Guid == guid) return this;
-      else {
-        for (int i = 0; i < mySubScopes.Count; i++) {
-          IScope s = mySubScopes[i].GetScope(guid);
-          if (s != null) return s;
-        }
-      }
-      return null;
-    }
-    /// <inheritdoc/>
     public IScope GetScope(string name) {
       if (Name == name) return this;
@@ -267,5 +256,5 @@
 
     /// <inheritdoc/>
-    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+    public override object Clone(IDictionary<long, object> clonedObjects) {
       Scope clone = (Scope)base.Clone(clonedObjects);
       clone.myName = Name;
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Variable.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Variable.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Variable.cs	(revision 2033)
@@ -102,7 +102,7 @@
     /// <param name="clonedObjects">Dictionary of all already cloned objects. (Needed to avoid cycles.)</param>
     /// <returns>The cloned object as <see cref="Variable"/>.</returns>
-    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+    public override object Clone(IDictionary<long, object> clonedObjects) {
       Variable clone = new Variable();
-      clonedObjects.Add(Guid, clone);
+      clonedObjects.Add(clone.Id, clone);
       clone.myName = Name;
       if (Value != null)
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/VariableInfo.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/VariableInfo.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/VariableInfo.cs	(revision 2033)
@@ -145,7 +145,7 @@
     /// <param name="clonedObjects">Dictionary of all already cloned objects. (Needed to avoid cycles.)</param>
     /// <returns>The cloned object as <see cref="VariableInfo"/>.</returns>
-    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+    public override object Clone(IDictionary<long, object> clonedObjects) {
       VariableInfo clone = new VariableInfo();
-      clonedObjects.Add(Guid, clone);
+      clonedObjects.Add(clone.Id, clone);
       clone.myActualName = ActualName;
       clone.myFormalName = FormalName;
Index: /branches/Operator Architecture Refactoring/HeuristicLab.OptimizationFrontend/3.3/MainForm.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.OptimizationFrontend/3.3/MainForm.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.OptimizationFrontend/3.3/MainForm.cs	(revision 2033)
@@ -37,11 +37,11 @@
     private class Task {
       public string filename;
-      public IStorable storable;
+      public object instance;
       public IEditor editor;
 
       private Task() { }
-      public Task(string filename, IStorable storable, IEditor editor) {
+      public Task(string filename, object instance, IEditor editor) {
         this.filename = filename;
-        this.storable = storable;
+        this.instance = instance;
         this.editor = editor;
       }
@@ -145,5 +145,5 @@
       Task task = (Task)state;
       try {
-        task.storable = PersistenceManager.Load(task.filename);
+        task.instance = PersistenceManager.Load(task.filename);
       } catch(FileNotFoundException ex) {
         MessageBox.Show("Sorry couldn't open file \"" + task.filename + "\".\nThe file or plugin \"" + ex.FileName + "\" is not available.\nPlease make sure you have all necessary plugins installed.",
@@ -162,6 +162,6 @@
       else {
         IEditor editor = null;
-        if(task.storable != null) {
-          IEditable editable = task.storable as IEditable;
+        if(task.instance != null) {
+          IEditable editable = task.instance as IEditable;
           if(editable != null)
             editor = editable.CreateEditor();
@@ -200,5 +200,5 @@
     private void AsynchronousSave(object state) {
       Task task = (Task)state;
-      PersistenceManager.Save(task.storable, task.filename);
+      PersistenceManager.Save(task.instance, task.filename);
       SaveFinished(task);
     }
Index: /branches/Operator Architecture Refactoring/HeuristicLab.ThreadParallelEngine/3.3/ThreadParallelEngine.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.ThreadParallelEngine/3.3/ThreadParallelEngine.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.ThreadParallelEngine/3.3/ThreadParallelEngine.cs	(revision 2033)
@@ -73,5 +73,5 @@
     /// <inheritdoc/>
     /// <returns>The cloned object as <see cref="ThreadParallelEngine"/>.</returns>
-    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+    public override object Clone(IDictionary<long, object> clonedObjects) {
       ThreadParallelEngine clone = (ThreadParallelEngine)base.Clone(clonedObjects);
       clone.myWorkers = Workers;
